fix various arch issues
[automated-distro-installer] / fai-redep
index d7ba0043f9979f1292f620168417974c9f41d0e3..29f4d158c5e832597e599db83cf97b408a0bbe12 100755 (executable)
--- a/fai-redep
+++ b/fai-redep
@@ -1,13 +1,34 @@
-#!/bin/bash -lx
+#!/bin/bash -l
+set -x
 
 # Deploy fai configuration to faiserver,
 # then start a virtual machine to test the config.
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
-ssh root@faiserver rm -rf /srv/fai/config/\*
-scp -r /a/bin/fai/fai/config root@faiserver:/srv/fai
+cd $(dirname $(readlink -f "$BASH_SOURCE"))
+
+
+faiserver_host=faiserver
+# i use faiserver as a dns alias, but ssh key is associated with
+# a canonical hostname and we will have ssh warning spam unless we
+# use it, so look it up.
+if addr=$(host faiserver); then
+    addr=${addr##* }
+    if h=$(host $addr); then
+        h=${h##* }
+        faiserver_host=${h%%.*}
+    else
+        echo "$0: warning: host \$addr($addr) failed"
+    fi
+else
+    echo "$0: warning: host faiserver failed"
+fi
+
+
+ssh root@$faiserver_host rm -rf /srv/fai/config
+scp -r fai/config root@$faiserver_host:/srv/fai
 # fai example pass: fai
 #ROOTPW='$1$kBnWcO.E$djxB128U7dMkrltJHPf6d1'
 
@@ -16,20 +37,28 @@ scp -r /a/bin/fai/fai/config root@faiserver:/srv/fai
 # echo "yoursecrectpassword" | mkpasswd -m sha-512 -s
 # On arch, best seems to be copy your shadow file to a temp location,
 # then passwd, get out the new pass, then copy the shadow file back.
-ssh root@faiserver tee -a /srv/fai/config/class/DEFAULT.var <<EOF
-ROOTPW='$(cat /p/shadow/standard)'
+
+f=/q/root/shadow/standard
+if s test -e $f; then
+    ssh root@$faiserver_host tee -a /srv/fai/config/class/DEFAULT.var <<EOF
+ROOTPW='$(s cat $f)'
 EOF
+fi
+
+tpvar="$(s cat /q/root/shadow/traci-simple)"
+ssh root@$faiserver_host tee -a /srv/fai/config/class/tp.var <<EOF
+ROOTPW='$tpvar'
+EOF
+
 scp ~/.ssh/id_rsa.pub \
-    root@faiserver:/srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
-s scp -r /q/root/luks root@faiserver:/srv/fai/config/distro-install-common
-ssh root@faiserver chmod -R a+rX /srv/fai/config/distro-install-common
-
-s virshrm demohost ||:
-
-for f in /var/lib/libvirt/images/demohost{,b}; do
-    [[ -e $f ]] || s qemu-img create -o preallocation=metadata -f qcow2 $f 30G
-done
-# osinfo-query os | gr jessie
-s virt-install --os-variant debian8 --cpu host -n demohost --pxe -r 2048 --vcpus 1 \
-  --disk path=/var/lib/libvirt/images/demohost \
-  --disk path=/var/lib/libvirt/images/demohostb -w bridge=br0,mac=52:54:00:9c:ef:ad
+    root@$faiserver_host:/srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
+# todo: automatically disable faiserver after a period so
+# these files are not exposed.
+s scp -r /q/root/luks /q/root/shadow/traci{,-simple} \
+  root@$faiserver_host:/srv/fai/config/distro-install-common
+scp /a/bin/devbyid root@$faiserver_host:/srv/fai/nfsroot/usr/local/bin
+ssh root@$faiserver_host bash <<'EOF'
+set -eE -o pipefail
+chmod 644 /srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
+chmod -R a+rX /srv/fai/config/distro-install-common
+EOF